


(*
   written by Oliver Bandel. => Urheber / COpyright Oliver Bandel

   This is free software and it can be redistributed under the
   General Public License (GPL) version 2.
*)



type entry_t = { host: string; date: string; request: string;
                 status: string; size: string; referrer: string; client: string }

type entry_type_t = Host | Date | Cmd | Retcode | Size | Referrer | Client | All


let create ~host:h ~date:d ~request:request ~status:rc ~size:s ~referrer:rf ~client:cl =
      { host = h; date = d; request = request; status = rc; size = s; referrer = rf; client = cl }

let host r = r.host
let date r = r.date
let request  r = r.request
let status  r = r.status 
let size  r = r.size 
let referrer r = r.referrer 
let client   r = r.client 



let name_of_entrytype t =
  match t with 
    Host     -> "host"
  | Date     -> "date"
  | Cmd      -> "request"
  | Retcode  -> "status"
  | Size     -> "size"
  | Referrer -> "referrer"
  | Client   -> "client"
  | All      -> "*"



let getval_by_typelist r tl =
  let rec aux eatup sample =
    match eatup with
      []     -> List.rev sample
    | hd::tl -> begin
                  match hd with
                    Host     -> aux tl (host r :: sample)
                  | Date     -> aux tl (date r :: sample)
                  | Cmd      -> aux tl (request r :: sample)
                  | Retcode  -> aux tl (status r :: sample)
                  | Size     -> aux tl (size r :: sample)
                  | Referrer -> aux tl (referrer r :: sample)
                  | Client   -> aux tl (client r :: sample)
                  | All      -> aux tl ( host r ::
                                         date r ::
                                         request r ::
                                         status r ::
                                         size r ::
                                         referrer r ::
                                         client r ::
                                         sample
                                       )
                end
  in
    List.rev (aux tl [])
