{

(*
   written by Oliver Bandel. => Urheber / COpyright Oliver Bandel

   This is free software and it can be redistributed under the
   General Public License (GPL) version 2.
*)


exception Scanner_error
let string_unquote s = String.sub s 1 (String.length s -2) (* remove first and last char *)
}


rule token = parse
    | ['['] [^']']* [']']  as string { (string_unquote string) }
    | ['"'] [^'"']* ['"']  as string { (string_unquote string) }
    | ['a'-'z' 'A'-'Z' '_' '-' '+' '.' '0'-'9' ]+ as word { (word) }
    | [' '  '\t' '\n' ] { token lexbuf }
    | ['-']             { "-" }
    | eof    { raise End_of_file }
    | _      { raise Scanner_error }


{
 (* nothing *)
}
