
(*
   written by Oliver Bandel. => Urheber / COpyright Oliver Bandel

   This is free software and it can be redistributed under the
   General Public License (GPL) version 2.
*)


open Querytypes


module LE = Logentry



let query() =

(* Abfrage-Query parsen :) *)
    begin
      try
        let lexbuf = Lexing.from_channel stdin in
          (*while true do*)
          let query_result = Retrievegrammar.main Retrievelex.token lexbuf in
          query_result
        with   End_of_file -> prerr_endline "EOF found!"; Quit
             | Parsing.Parse_error -> prerr_endline "Parse Error!"; Error
    end

let rec loop() =
  print_string "# "; flush stdout; (* print a prompt for the user *)
  match query()
  with   Error -> prerr_endline "ERRRRRRROR!";
                  prerr_endline "try it again! ";
                  loop()
       | Quit -> prerr_endline "good bye, darling! :)"; exit 0
       | Query query ->

               (*
               print_endline query.file;
               *)
               let entrylist = Readlog.readlog query.file in
               let filtered = List.filter (fun entry -> match query.cond with None -> true | Some filt -> filt entry) entrylist in
               List.iter (fun entry -> Printf.printf "%s\n" (String.concat ", " (LE.getval_by_typelist entry query.sel)) ) filtered;
               flush stdout;
               loop()
               (*
               print_endline "___READY!___";
               *)

(*

val getval_by_typelist : entry_t -> entry_type_t list -> string list
  val cond : (Logentry.entry_t -> bool) option;


(* Logfile lesen und eine Minimal-Ausgabe ausgeben *)
   List.iter (fun entry -> Printf.printf "***\n%s\n%s\n%s\n" (Logentry.host entry) (Logentry.date entry) (Logentry.referrer entry)) result

*)



let _ = loop ()



