type token =
  | NOT
  | OR
  | AND
  | LPAR
  | RPAR
  | EQUALS
  | SMALLER
  | GREATER
  | NOT_EQUAL
  | LIKE
  | SEMICOLON
  | COMMA
  | ASTERISK
  | SELECT
  | FROM
  | WHERE
  | GROUP
  | ENTRY_HOST
  | ENTRY_DATE
  | ENTRY_REQUEST
  | ENTRY_STATUS
  | ENTRY_SIZE
  | ENTRY_REFERRER
  | ENTRY_CLIENT
  | QUIT_COMMAND
  | STRING of (string)
  | INT of (string)
  | NAME of (string)

open Parsing;;
# 10 "retrievegrammar.mly"
exception Undefined_value of string

open Querytypes
open Logentry
let string_unquote s = String.sub s 1 (String.length s -2)

let make_comp sel const cmp r =
  cmp (sel r) const



(*
<spaltenname> LIKE  <wert>
        <wert> kann dabei Jokerzeichen enthalten :
                %   für beliebig viele unbek. Zeichen
                _   für ein  Zeichen



   s/_/\./g;
   s/%/\.\*/g;
*)
let like_test contents like_re =
  let re_underscore = Str.regexp "_" in
  let re_percent = Str.regexp "%" in

  let re_string = Str.global_replace re_percent ".*" (Str.global_replace re_underscore "." like_re) in
  (*
  print_endline re_string;
  *)

  Str.string_match (Str.regexp ( "^" ^ re_string ^ "$")) contents 0
    (* partial application! *)
  
  


(** compares int-strings like int's,
    but when a value can't be converted to an int,
    it assumes the value -1 for it's conversion!
*)
let savicmp x y =
  compare ( try int_of_string x with _ -> -1) ( try int_of_string y with _ -> -1)

let savi_equal     x y =  ( try int_of_string x with _ -> -1)  =  ( try int_of_string y with _ -> -1)
let savi_not_equal x y =  not (( try int_of_string x with _ -> -1)  =  ( try int_of_string y with _ -> -1))
let savi_smaller   x y =  ( try int_of_string x with _ -> -1)  <  ( try int_of_string y with _ -> -1)
let savi_greater   x y =  ( try int_of_string x with _ -> -1)  >  ( try int_of_string y with _ -> -1)

(*
  how to use make_comp:
let acomp_eq_77 = make_comp Logentry.host "lj511571.crawl.yahoo.net"  (fun x y -> x = y )

*)

module L = Logentry



(*
  Query:
    * Select-List
    * filename: string
    * condition: condtype option

*)



# 103 "retrievegrammar.ml"
let yytransl_const = [|
  257 (* NOT *);
  258 (* OR *);
  259 (* AND *);
  260 (* LPAR *);
  261 (* RPAR *);
  262 (* EQUALS *);
  263 (* SMALLER *);
  264 (* GREATER *);
  265 (* NOT_EQUAL *);
  266 (* LIKE *);
  267 (* SEMICOLON *);
  268 (* COMMA *);
  269 (* ASTERISK *);
  270 (* SELECT *);
  271 (* FROM *);
  272 (* WHERE *);
  273 (* GROUP *);
  274 (* ENTRY_HOST *);
  275 (* ENTRY_DATE *);
  276 (* ENTRY_REQUEST *);
  277 (* ENTRY_STATUS *);
  278 (* ENTRY_SIZE *);
  279 (* ENTRY_REFERRER *);
  280 (* ENTRY_CLIENT *);
  281 (* QUIT_COMMAND *);
    0|]

let yytransl_block = [|
  282 (* STRING *);
  283 (* INT *);
  284 (* NAME *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\002\000\002\000\004\000\003\000\006\000\006\000\
\007\000\007\000\008\000\008\000\008\000\008\000\008\000\008\000\
\009\000\009\000\005\000\005\000\005\000\005\000\005\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\011\000\011\000\011\000\011\000\011\000\013\000\013\000\012\000\
\014\000\000\000"

let yylen = "\002\000\
\002\000\002\000\004\000\006\000\001\000\001\000\001\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\003\000\002\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\042\000\000\000\016\000\011\000\
\012\000\013\000\017\000\018\000\014\000\015\000\000\000\000\000\
\007\000\009\000\010\000\002\000\001\000\000\000\000\000\005\000\
\000\000\008\000\000\000\000\000\000\000\033\000\034\000\035\000\
\038\000\039\000\036\000\037\000\000\000\019\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\020\000\000\000\022\000\
\040\000\024\000\026\000\027\000\025\000\028\000\041\000\029\000\
\031\000\032\000\030\000"

let yydgoto = "\002\000\
\005\000\006\000\015\000\025\000\037\000\016\000\017\000\018\000\
\019\000\038\000\039\000\058\000\040\000\064\000"

let yysindex = "\003\000\
\243\254\000\000\013\255\251\254\000\000\253\254\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\034\255\041\255\
\000\000\000\000\000\000\000\000\000\000\028\255\013\255\000\000\
\039\255\000\000\255\254\255\254\255\254\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\049\255\000\000\032\255\021\255\
\049\255\045\255\255\254\255\254\030\255\030\255\030\255\030\255\
\030\255\031\255\031\255\031\255\031\255\000\000\054\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\044\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\050\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\051\255\000\000\000\000\000\000\
\002\255\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\000\000\000\000\237\255\000\000\037\000\000\000\
\000\000\000\000\000\000\253\255\000\000\219\255"

let yytablesize = 62
let yytable = "\028\000\
\003\000\023\000\029\000\001\000\023\000\020\000\021\000\021\000\
\041\000\042\000\023\000\004\000\021\000\065\000\066\000\067\000\
\030\000\031\000\032\000\033\000\034\000\035\000\036\000\055\000\
\056\000\007\000\050\000\051\000\052\000\053\000\008\000\009\000\
\010\000\011\000\012\000\013\000\014\000\045\000\046\000\047\000\
\048\000\049\000\059\000\060\000\061\000\062\000\043\000\044\000\
\022\000\054\000\043\000\044\000\023\000\024\000\027\000\057\000\
\044\000\063\000\006\000\026\000\003\000\004\000"

let yycheck = "\001\001\
\014\001\002\001\004\001\001\000\005\001\011\001\005\001\011\001\
\028\000\029\000\011\001\025\001\011\001\051\000\052\000\053\000\
\018\001\019\001\020\001\021\001\022\001\023\001\024\001\043\000\
\044\000\013\001\006\001\007\001\008\001\009\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\006\001\007\001\008\001\
\009\001\010\001\046\000\047\000\048\000\049\000\002\001\003\001\
\015\001\005\001\002\001\003\001\012\001\026\001\016\001\026\001\
\003\001\027\001\015\001\023\000\011\001\011\001"

let yynames_const = "\
  NOT\000\
  OR\000\
  AND\000\
  LPAR\000\
  RPAR\000\
  EQUALS\000\
  SMALLER\000\
  GREATER\000\
  NOT_EQUAL\000\
  LIKE\000\
  SEMICOLON\000\
  COMMA\000\
  ASTERISK\000\
  SELECT\000\
  FROM\000\
  WHERE\000\
  GROUP\000\
  ENTRY_HOST\000\
  ENTRY_DATE\000\
  ENTRY_REQUEST\000\
  ENTRY_STATUS\000\
  ENTRY_SIZE\000\
  ENTRY_REFERRER\000\
  ENTRY_CLIENT\000\
  QUIT_COMMAND\000\
  "

let yynames_block = "\
  STRING\000\
  INT\000\
  NAME\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'select) in
    Obj.repr(
# 107 "retrievegrammar.mly"
                       ( Query _1 )
# 257 "retrievegrammar.ml"
               : Querytypes.query_result))
; (fun __caml_parser_env ->
    Obj.repr(
# 108 "retrievegrammar.mly"
                               ( Quit )
# 263 "retrievegrammar.ml"
               : Querytypes.query_result))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'sel) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'file) in
    Obj.repr(
# 112 "retrievegrammar.mly"
                             ( { sel = _2; file = _4; cond = None } )
# 271 "retrievegrammar.ml"
               : 'select))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'sel) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'file) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'cond) in
    Obj.repr(
# 113 "retrievegrammar.mly"
                                        ( { sel = _2; file = _4; cond = Some _6 } )
# 280 "retrievegrammar.ml"
               : 'select))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 117 "retrievegrammar.mly"
             ( _1 )
# 287 "retrievegrammar.ml"
               : 'file))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'elem_list) in
    Obj.repr(
# 119 "retrievegrammar.mly"
               ( _1 )
# 294 "retrievegrammar.ml"
               : 'sel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'elem) in
    Obj.repr(
# 124 "retrievegrammar.mly"
                ( [ _1 ] )
# 301 "retrievegrammar.ml"
               : 'elem_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'elem) in
    Obj.repr(
# 125 "retrievegrammar.mly"
                                    ( _3 :: _1 )
# 309 "retrievegrammar.ml"
               : 'elem_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 129 "retrievegrammar.mly"
                  ( _1 )
# 316 "retrievegrammar.ml"
               : 'elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'int_elem) in
    Obj.repr(
# 130 "retrievegrammar.mly"
                  ( _1 )
# 323 "retrievegrammar.ml"
               : 'elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 133 "retrievegrammar.mly"
                             ( Host )
# 329 "retrievegrammar.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 134 "retrievegrammar.mly"
                      ( Date )
# 335 "retrievegrammar.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 135 "retrievegrammar.mly"
                          ( Cmd )
# 341 "retrievegrammar.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 136 "retrievegrammar.mly"
                      ( Referrer )
# 347 "retrievegrammar.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 137 "retrievegrammar.mly"
                      ( Client )
# 353 "retrievegrammar.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 138 "retrievegrammar.mly"
                  ( All )
# 359 "retrievegrammar.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 142 "retrievegrammar.mly"
                        ( Retcode )
# 365 "retrievegrammar.ml"
               : 'int_elem))
; (fun __caml_parser_env ->
    Obj.repr(
# 143 "retrievegrammar.mly"
                         ( Size )
# 371 "retrievegrammar.ml"
               : 'int_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_simple) in
    Obj.repr(
# 149 "retrievegrammar.mly"
                   ( _1 )
# 378 "retrievegrammar.ml"
               : 'cond))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cond) in
    Obj.repr(
# 150 "retrievegrammar.mly"
                      ( _2 )
# 385 "retrievegrammar.ml"
               : 'cond))
; (fun __caml_parser_env ->
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cond) in
    Obj.repr(
# 151 "retrievegrammar.mly"
                ( let not_cond r = not (_2 r) in not_cond )
# 392 "retrievegrammar.ml"
               : 'cond))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cond) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cond) in
    Obj.repr(
# 152 "retrievegrammar.mly"
                     ( let and_cond c1 c2 r = (c1 r) && (c2 r) in and_cond _1 _3 )
# 400 "retrievegrammar.ml"
               : 'cond))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cond) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'cond) in
    Obj.repr(
# 153 "retrievegrammar.mly"
                    ( let and_cond c1 c2 r = (c1 r) || (c2 r) in and_cond _1 _3 )
# 408 "retrievegrammar.ml"
               : 'cond))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_s) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_s) in
    Obj.repr(
# 156 "retrievegrammar.mly"
                                            ( make_comp _1 _3 ( = ) )
# 416 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_s) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_s) in
    Obj.repr(
# 157 "retrievegrammar.mly"
                                       ( make_comp _1 _3 ( <> ) )
# 424 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_s) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_s) in
    Obj.repr(
# 158 "retrievegrammar.mly"
                                     ( make_comp _1 _3 ( < ) )
# 432 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_s) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_s) in
    Obj.repr(
# 159 "retrievegrammar.mly"
                                     ( make_comp _1 _3 ( > ) )
# 440 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_s) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_s) in
    Obj.repr(
# 160 "retrievegrammar.mly"
                                  ( make_comp _1 _3 ( like_test ) (* ?????? AENDERN! ?????? *) )
# 448 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_i) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_i) in
    Obj.repr(
# 162 "retrievegrammar.mly"
                                     ( make_comp _1 _3 ( savi_equal ) )
# 456 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_i) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_i) in
    Obj.repr(
# 163 "retrievegrammar.mly"
                                       ( make_comp _1 _3 ( savi_not_equal ) )
# 464 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_i) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_i) in
    Obj.repr(
# 164 "retrievegrammar.mly"
                                     ( make_comp _1 _3 ( savi_smaller ) )
# 472 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'elem_select_i) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_i) in
    Obj.repr(
# 165 "retrievegrammar.mly"
                                     ( make_comp _1 _3 ( savi_greater ) )
# 480 "retrievegrammar.ml"
               : 'cond_simple))
; (fun __caml_parser_env ->
    Obj.repr(
# 169 "retrievegrammar.mly"
                          ( L.host )
# 486 "retrievegrammar.ml"
               : 'elem_select_s))
; (fun __caml_parser_env ->
    Obj.repr(
# 170 "retrievegrammar.mly"
                        ( L.date )
# 492 "retrievegrammar.ml"
               : 'elem_select_s))
; (fun __caml_parser_env ->
    Obj.repr(
# 171 "retrievegrammar.mly"
                            ( L.request )
# 498 "retrievegrammar.ml"
               : 'elem_select_s))
; (fun __caml_parser_env ->
    Obj.repr(
# 172 "retrievegrammar.mly"
                        ( L.referrer )
# 504 "retrievegrammar.ml"
               : 'elem_select_s))
; (fun __caml_parser_env ->
    Obj.repr(
# 173 "retrievegrammar.mly"
                        ( L.client )
# 510 "retrievegrammar.ml"
               : 'elem_select_s))
; (fun __caml_parser_env ->
    Obj.repr(
# 176 "retrievegrammar.mly"
                               ( L.status )
# 516 "retrievegrammar.ml"
               : 'elem_select_i))
; (fun __caml_parser_env ->
    Obj.repr(
# 177 "retrievegrammar.mly"
                        ( L.size )
# 522 "retrievegrammar.ml"
               : 'elem_select_i))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 189 "retrievegrammar.mly"
                 ( _1 )
# 529 "retrievegrammar.ml"
               : 'const_s))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string) in
    Obj.repr(
# 194 "retrievegrammar.mly"
                 ( _1 )
# 536 "retrievegrammar.ml"
               : 'const_i))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Querytypes.query_result)
;;
